// FILENAME:	SS_10th_Anniversary.cs
// 
// AUTHOR:  	Drake~{DWR}-;)
//---------------------------------------------------------------------
//
//	Note: Rotation -
//		%x = getPosition(%target, x);
//		%y = getPosition(%target, y);
//		%z = getPosition(%target, z);
//		setPosition(%target, %x, %y, %z, %rotation, %angle);
//---------------------------------------------------------------------

$missionName = "SS_10th_Anniversary";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

$afk1user = "";
$fireworks = true;

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = false;	
}

function onMissionLoad()
{
	// Blank
}

function onMissionStart()
{
	$afk1 = getObjectId("MissionGroup\\afk1");
	$afk2 = getObjectId("MissionGroup\\afk2");
	$afk3 = getObjectId("MissionGroup\\afk3");
	$afk4 = getObjectId("MissionGroup\\afk4");
	$launcher = getObjectId("MissionGroup\\fireworks\\launcher");
	$launcher2 = getObjectId("MissionGroup\\fireworks\\launcher2");
	temperateSounds();
	doubleLaunch();

	//
	// Saving incase troubles arise and only 1 fireworks launcher
	// is required..if any at all.
	// 
	// launch($launcher, 1600);
}

function player::onAdd(%player)
{
	say(%player, 0, "<f4>Currently Under Construction...");
	%player.wasafk = false;
	%player.afkpad = "";
}

function setAFK::trigger::onEnter(%this, %object)
{
	%player = playerManager::vehicleIdToPlayerNum(%object);
	if($afk1user != "")
	{
		setPosition(%object, 115.197, 1849.77, 50.101);
		say(%player, 1, "<F4>AFK Pad in use by " @ $afk1user @ "<F4>. Please wait until " @ $afk1user @ "<F4> has returned.");
	}
	else if($afk1user == "")
	{
	say(%player, 1, "<F4>AFK Area - Shut down to use.");
	}
}

function setAFK::trigger::onContact(%this, %object)
{
	%player = playerManager::vehicleIdToPlayerNum(%object);
	if(isShutDown(%object))
	{
		$afk1user = getHudName(%object);
		healObject(%object, 99999999);
		reloadObject(%object, 5000);
		setShapeVisibility($afk1, true);
		setShapeVisibility($afk2, true);
		setShapeVisibility($afk3, true);
		setShapeVisibility($afk4, true);
		playSound(%object, "sfx_electrical_bzzt.wav", IDPRF_NEAR);
		%player.wasafk = true;
	}
	else
	{
		$afk1user = "";
		setShapeVisibility($afk1, false);
		setShapeVisibility($afk2, false);
		setShapeVisibility($afk3, false);
		setShapeVisibility($afk4, false);
	}
}

function setAFK::trigger::onLeave(%this, %object)
{
	%player = playerManager::vehicleIdToPlayerNum(%object);
	if(%player.wasafk == true)
	{
		say(%player, 1, "<F4>Welcome back " @ getHudName(%object) @ "<F4>!");
		%player.wasafk = false;
	}
}

function fireworks(%height, %x, %y, %z)
{
	if(%height == "")
	{
		%height = 1600;
	}
	if(%x == "")
	{
		%x = 0;
	}
	if(%y == "")
	{
		%y = 0;
	}
	if(%z == "")
	{
		%z = 0;
	}
	droppod(%x, %y, %z, %x, %y, %height);
	for(%i=0; %i<299; %i++)
	{
		%rX=randomint(%x-4000,%x+4000);
		%rY=randomint(%y-4000,%y+4000);
		schedule("dropPod("@ %x @","@ %y @","@ %height @","@ %rX @","@ %rY @","@ %height @");",%height/400);
		schedule("dropPod("@ %x @","@ %y @","@ %height @","@ %rX @","@ %rY @","@ getTerrainheight(%rX,%ry) @");", %height/400);
	}
}

function launch(%object, %height)
{
	if($fireworks == true)
	{
		%x = getPosition(%object, x);
		%y = getPosition(%object, y);
		%z = getPosition(%object, z);

		fireworks(%height, %x, %y, %z);
	}
	// schedule("launch("@ %object @", "@ %height @");", %height/100);
}

function doubleLaunch()
{
	launch($launcher, 1600);
	schedule("launch(" @ $launcher2 @ ", 1600);", 16);
	schedule("doubleLaunch();", 32);
}